<?php
class ControllerExtensionPaymentTrustPay extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/trustpay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_trustpay', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['email'])) {
			$data['error_email'] = $this->error['email'];
		} else {
			$data['error_email'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/trustpay', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/trustpay', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_trustpay_key'])) {
			$data['payment_trustpay_key'] = $this->request->post['payment_trustpay_key'];
		} else {
			$data['payment_trustpay_key'] = $this->config->get('payment_trustpay_key');
		}

		if (isset($this->request->post['payment_trustpay_secret'])) {
			$data['payment_trustpay_secret'] = $this->request->post['payment_trustpay_secret'];
		} else {
			$data['payment_trustpay_secret'] = $this->config->get('payment_trustpay_secret');
		}

		if (isset($this->request->post['payment_trustpay_transaction'])) {
			$data['payment_trustpay_transaction'] = $this->request->post['payment_trustpay_transaction'];
		} else {
			$data['payment_trustpay_transaction'] = $this->config->get('payment_trustpay_transaction');
		}

		if (isset($this->request->post['payment_trustpay_total'])) {
			$data['payment_trustpay_total'] = $this->request->post['payment_trustpay_total'];
		} else {
			$data['payment_trustpay_total'] = $this->config->get('payment_trustpay_total');
		}

		if (isset($this->request->post['payment_trustpay_canceled_reversal_status_id'])) {
			$data['payment_trustpay_canceled_reversal_status_id'] = $this->request->post['payment_trustpay_canceled_reversal_status_id'];
		} else {
			$data['payment_trustpay_canceled_reversal_status_id'] = $this->config->get('payment_trustpay_canceled_reversal_status_id');
		}

		if (isset($this->request->post['payment_trustpay_completed_status_id'])) {
			$data['payment_trustpay_completed_status_id'] = $this->request->post['payment_trustpay_completed_status_id'];
		} else {
			$data['payment_trustpay_completed_status_id'] = $this->config->get('payment_trustpay_completed_status_id');
		}

		if (isset($this->request->post['payment_trustpay_denied_status_id'])) {
			$data['payment_trustpay_denied_status_id'] = $this->request->post['payment_trustpay_denied_status_id'];
		} else {
			$data['payment_trustpay_denied_status_id'] = $this->config->get('payment_trustpay_denied_status_id');
		}

		if (isset($this->request->post['payment_trustpay_expired_status_id'])) {
			$data['payment_trustpay_expired_status_id'] = $this->request->post['payment_trustpay_expired_status_id'];
		} else {
			$data['payment_trustpay_expired_status_id'] = $this->config->get('payment_trustpay_expired_status_id');
		}

		if (isset($this->request->post['payment_trustpay_failed_status_id'])) {
			$data['payment_trustpay_failed_status_id'] = $this->request->post['payment_trustpay_failed_status_id'];
		} else {
			$data['payment_trustpay_failed_status_id'] = $this->config->get('payment_trustpay_failed_status_id');
		}

		if (isset($this->request->post['payment_trustpay_pending_status_id'])) {
			$data['payment_trustpay_pending_status_id'] = $this->request->post['payment_trustpay_pending_status_id'];
		} else {
			$data['payment_trustpay_pending_status_id'] = $this->config->get('payment_trustpay_pending_status_id');
		}

		if (isset($this->request->post['payment_trustpay_processed_status_id'])) {
			$data['payment_trustpay_processed_status_id'] = $this->request->post['payment_trustpay_processed_status_id'];
		} else {
			$data['payment_trustpay_processed_status_id'] = $this->config->get('payment_trustpay_processed_status_id');
		}

		if (isset($this->request->post['payment_trustpay_refunded_status_id'])) {
			$data['payment_trustpay_refunded_status_id'] = $this->request->post['payment_trustpay_refunded_status_id'];
		} else {
			$data['payment_trustpay_refunded_status_id'] = $this->config->get('payment_trustpay_refunded_status_id');
		}

		if (isset($this->request->post['payment_trustpay_reversed_status_id'])) {
			$data['payment_trustpay_reversed_status_id'] = $this->request->post['payment_trustpay_reversed_status_id'];
		} else {
			$data['payment_trustpay_reversed_status_id'] = $this->config->get('payment_trustpay_reversed_status_id');
		}

		if (isset($this->request->post['payment_trustpay_voided_status_id'])) {
			$data['payment_trustpay_voided_status_id'] = $this->request->post['payment_trustpay_voided_status_id'];
		} else {
			$data['payment_trustpay_voided_status_id'] = $this->config->get('payment_trustpay_voided_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_trustpay_geo_zone_id'])) {
			$data['payment_trustpay_geo_zone_id'] = $this->request->post['payment_trustpay_geo_zone_id'];
		} else {
			$data['payment_trustpay_geo_zone_id'] = $this->config->get('payment_trustpay_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_trustpay_status'])) {
			$data['payment_trustpay_status'] = $this->request->post['payment_trustpay_status'];
		} else {
			$data['payment_trustpay_status'] = $this->config->get('payment_trustpay_status');
		}

		if (isset($this->request->post['payment_trustpay_sort_order'])) {
			$data['payment_trustpay_sort_order'] = $this->request->post['payment_trustpay_sort_order'];
		} else {
			$data['payment_trustpay_sort_order'] = $this->config->get('payment_trustpay_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/trustpay', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/trustpay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['payment_trustpay_key']) {
			$this->error['email'] = $this->language->get('error_email');
		}

		if (!$this->request->post['payment_trustpay_secret']) {
			$this->error['email'] = $this->language->get('error_email');
		}

		return !$this->error;
	}
}