<?php
class ControllerExtensionPaymentTrustPay extends Controller {
	public function index() {
		$this->load->language('extension/payment/trustpay');

		$data['text_testmode'] = $this->language->get('text_testmode');
		$data['button_confirm'] = $this->language->get('button_confirm');

		$data['testmode'] = $this->config->get('payment_trustpay_test');

		if (!$this->config->get('payment_trustpay_test')) {
			$data['action'] = 'https://apimomoweb.trustpay.africa/choosePaymentType.php';
		} 
	

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$order_id = $this->session->data['order_id'];

		if ($order_info) {
			$data['payment_trustpay_key'] = $this->config->get('payment_trustpay_key');
			$data['payment_trustpay_secret'] = $this->config->get('payment_trustpay_secret');
			$data['item_name'] = html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8');

			$data['products'] = array();

			foreach ($this->cart->getProducts() as $product) {
				$option_data = array();

				foreach ($product['option'] as $option) {
					if ($option['type'] != 'file') {
						$value = $option['value'];
					} else {
						$upload_info = $this->model_tool_upload->getUploadByCode($option['value']);
						
						if ($upload_info) {
							$value = $upload_info['name'];
						} else {
							$value = '';
						}
					}

					$option_data[] = array(
						'name'  => $option['name'],
						'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value)
					);
				}

				$data['products'][] = array(
					'name'     => htmlspecialchars($product['name']),
					'model'    => htmlspecialchars($product['model']),
					'price'    => $this->currency->format($product['price'], $order_info['currency_code'], false, false),
					'quantity' => $product['quantity'],
					'option'   => $option_data,
					'weight'   => $product['weight']
				);
			}

			$data['discount_amount_cart'] = 0;

			$total = $this->currency->format($order_info['total'] - $this->cart->getSubTotal(), $order_info['currency_code'], false, false);

			if ($total > 0) {
				$data['products'][] = array(
					'name'     => $this->language->get('text_total'),
					'model'    => '',
					'price'    => $total,
					'quantity' => 1,
					'option'   => array(),
					'weight'   => 0
				);
			} else {
				$data['discount_amount_cart'] -= $total;
			}

			$data['total_amount'] = round($order_info['total'],2);
			$data['currency_code'] = $order_info['currency_code'];
			$data['first_name'] = $order_info['payment_firstname'];
			$data['last_name'] = $order_info['payment_lastname'];
			$data['address1'] = $order_info['payment_address_1'];
			$data['address2'] = $order_info['payment_address_2'];
			$data['city'] = $order_info['payment_city'];
			$data['zip'] = $order_info['payment_postcode'];
			$data['country'] = $order_info['payment_iso_code_2'];
			$data['email'] = $order_info['email'];
			$data['invoice'] = $this->session->data['order_id'] . ' - ' . $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
			$data['lc'] = $this->session->data['language'];
			$data['return'] = $this->url->link('checkout/success');
			$data['notify_url'] = $this->url->link('extension/payment/trustpay/callback', '', true);
			$data['cancel_return'] = $this->url->link('checkout/checkout', '', true);

			if (!$this->config->get('payment_trustpay_transaction')) {
				$data['paymentaction'] = 'authorization';
			} else {
				$data['paymentaction'] = 'sale';
			}

			$data['custom'] = $this->session->data['order_id'];

			return $this->load->view('extension/payment/trustpay', $data);
		}
	}

	public function callback() {
		if (isset($_POST['order'])	) {
			$order = $_POST['order'];
			echo $order;					
		}

		if (isset($this->request->post['result'])) {
			$status = $this->request->post['result'];
		} else {
			$status = 0;
		}

		if (isset($this->request->post['rkey'])) {
			$rkey = $this->request->post['rkey'];
		} else {
			$rkey = 0;
		}

		if (isset($this->request->post['merchant'])) {
			$merchant = $this->request->post['merchant'];
		} else {
			$merchant = 0;
		}

		// if (isset($this->request->post['checksum'])) {
		// 	$checksum = $this->request->post['checksum'];
		// } else {
		// 	$checksum = 0;
		// }

		if (!empty($status) && !empty($rkey) && !empty($merchant) && !empty($order)) {
			$result = md5($status.$merchant.$order.$rkey);
			$order_id = $this->session->data['order_id'];

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($order_id);

				if ($result == $checksum) {
					echo $result;
				} else{
					echo 'checksum';					
				}

			if ($result == $checksum) {
				if ($status == "Y") {
					$order_status_id = $this->config->get('payment_trustpay_processed_status_id');
					$this->model_checkout_order->addOrderHistory($order_id, $order_status_id);
					$this->response->redirect($this->url->link('checkout/success', '', true));
					$this->language->get('text_success');
				} else{
					$order_status_id = $this->config->get('payment_trustpay_denied_status_id');
					echo "Success";
					$this->model_checkout_order->addOrderHistory($order_id, $order_status_id);
					$this->response->redirect($this->url->link('checkout/failure', '', true));
					$this->language->get('text_failed');

				}

			} else{
				$order_status_id = $this->config->get('payment_trustpay_voided_status_id');
				$this->model_checkout_order->addOrderHistory($order_id, $order_status_id);
			}
			
		} else {
				$this->response->redirect($this->url->link('checkout/failure', '', true));
		}
		}
	}
